Index: pjproject/trunk/aconfigure
===================================================================
--- pjproject/trunk/aconfigure	(revision 1583)
+++ pjproject/trunk/aconfigure	(revision 1584)
@@ -5695,4 +5695,149 @@
   cat >>confdefs.h <<\_ACEOF
 #define PJ_HAS_NETINET_IP_H 1
+_ACEOF
+
+fi
+
+
+if test "${ac_cv_header_net_if_h+set}" = set; then
+  echo "$as_me:$LINENO: checking for net/if.h" >&5
+echo $ECHO_N "checking for net/if.h... $ECHO_C" >&6
+if test "${ac_cv_header_net_if_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+fi
+echo "$as_me:$LINENO: result: $ac_cv_header_net_if_h" >&5
+echo "${ECHO_T}$ac_cv_header_net_if_h" >&6
+else
+  # Is the header compilable?
+echo "$as_me:$LINENO: checking net/if.h usability" >&5
+echo $ECHO_N "checking net/if.h usability... $ECHO_C" >&6
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+$ac_includes_default
+#include <net/if.h>
+_ACEOF
+rm -f conftest.$ac_objext
+if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
+  (eval $ac_compile) 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } &&
+	 { ac_try='test -z "$ac_c_werror_flag"
+			 || test ! -s conftest.err'
+  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }; } &&
+	 { ac_try='test -s conftest.$ac_objext'
+  { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
+  (eval $ac_try) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }; }; then
+  ac_header_compiler=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+ac_header_compiler=no
+fi
+rm -f conftest.err conftest.$ac_objext conftest.$ac_ext
+echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
+echo "${ECHO_T}$ac_header_compiler" >&6
+
+# Is the header present?
+echo "$as_me:$LINENO: checking net/if.h presence" >&5
+echo $ECHO_N "checking net/if.h presence... $ECHO_C" >&6
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <net/if.h>
+_ACEOF
+if { (eval echo "$as_me:$LINENO: \"$ac_cpp conftest.$ac_ext\"") >&5
+  (eval $ac_cpp conftest.$ac_ext) 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null; then
+  if test -s conftest.err; then
+    ac_cpp_err=$ac_c_preproc_warn_flag
+    ac_cpp_err=$ac_cpp_err$ac_c_werror_flag
+  else
+    ac_cpp_err=
+  fi
+else
+  ac_cpp_err=yes
+fi
+if test -z "$ac_cpp_err"; then
+  ac_header_preproc=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+  ac_header_preproc=no
+fi
+rm -f conftest.err conftest.$ac_ext
+echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
+echo "${ECHO_T}$ac_header_preproc" >&6
+
+# So?  What about this header?
+case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
+  yes:no: )
+    { echo "$as_me:$LINENO: WARNING: net/if.h: accepted by the compiler, rejected by the preprocessor!" >&5
+echo "$as_me: WARNING: net/if.h: accepted by the compiler, rejected by the preprocessor!" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h: proceeding with the compiler's result" >&5
+echo "$as_me: WARNING: net/if.h: proceeding with the compiler's result" >&2;}
+    ac_header_preproc=yes
+    ;;
+  no:yes:* )
+    { echo "$as_me:$LINENO: WARNING: net/if.h: present but cannot be compiled" >&5
+echo "$as_me: WARNING: net/if.h: present but cannot be compiled" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h:     check for missing prerequisite headers?" >&5
+echo "$as_me: WARNING: net/if.h:     check for missing prerequisite headers?" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h: see the Autoconf documentation" >&5
+echo "$as_me: WARNING: net/if.h: see the Autoconf documentation" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h:     section \"Present But Cannot Be Compiled\"" >&5
+echo "$as_me: WARNING: net/if.h:     section \"Present But Cannot Be Compiled\"" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h: proceeding with the preprocessor's result" >&5
+echo "$as_me: WARNING: net/if.h: proceeding with the preprocessor's result" >&2;}
+    { echo "$as_me:$LINENO: WARNING: net/if.h: in the future, the compiler will take precedence" >&5
+echo "$as_me: WARNING: net/if.h: in the future, the compiler will take precedence" >&2;}
+    (
+      cat <<\_ASBOX
+## ------------------------------------ ##
+## Report this to the pjproject lists.  ##
+## ------------------------------------ ##
+_ASBOX
+    ) |
+      sed "s/^/$as_me: WARNING:     /" >&2
+    ;;
+esac
+echo "$as_me:$LINENO: checking for net/if.h" >&5
+echo $ECHO_N "checking for net/if.h... $ECHO_C" >&6
+if test "${ac_cv_header_net_if_h+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_header_net_if_h=$ac_header_preproc
+fi
+echo "$as_me:$LINENO: result: $ac_cv_header_net_if_h" >&5
+echo "${ECHO_T}$ac_cv_header_net_if_h" >&6
+
+fi
+if test $ac_cv_header_net_if_h = yes; then
+  cat >>confdefs.h <<\_ACEOF
+#define PJ_HAS_NET_IF_H 1
 _ACEOF
 
Index: pjproject/trunk/aconfigure.ac
===================================================================
--- pjproject/trunk/aconfigure.ac	(revision 1583)
+++ pjproject/trunk/aconfigure.ac	(revision 1584)
@@ -144,4 +144,5 @@
 AC_CHECK_HEADER(netinet/in.h,[AC_DEFINE(PJ_HAS_NETINET_IN_H,1)])
 AC_CHECK_HEADER(netinet/ip.h,[AC_DEFINE(PJ_HAS_NETINET_IP_H,1)])
+AC_CHECK_HEADER(net/if.h,[AC_DEFINE(PJ_HAS_NET_IF_H,1)])
 AC_CHECK_HEADER(setjmp.h,[AC_DEFINE(PJ_HAS_SETJMP_H,1)])
 AC_CHECK_HEADER(stdarg.h,[AC_DEFINE(PJ_HAS_STDARG_H,1)])
Index: pjproject/trunk/pjlib/include/pj/compat/os_auto.h.in
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/os_auto.h.in	(revision 1583)
+++ pjproject/trunk/pjlib/include/pj/compat/os_auto.h.in	(revision 1584)
@@ -52,4 +52,5 @@
 #undef PJ_HAS_NETINET_IN_H
 #undef PJ_HAS_NETINET_IP_H
+#undef PJ_HAS_NET_IF_H
 #undef PJ_HAS_SETJMP_H
 #undef PJ_HAS_STDARG_H
Index: pjproject/trunk/pjlib/include/pj/compat/socket.h
===================================================================
--- pjproject/trunk/pjlib/include/pj/compat/socket.h	(revision 1583)
+++ pjproject/trunk/pjlib/include/pj/compat/socket.h	(revision 1584)
@@ -56,4 +56,9 @@
 /* To pull in IPTOS_* constants */
 #  include <netinet/ip.h>
+#endif
+
+#if defined(PJ_HAS_NET_IF_H) && PJ_HAS_NET_IF_H != 0
+/* For interface enumeration in ip_helper */
+#   include <net/if.h>
 #endif
 
Index: pjproject/trunk/pjlib/src/pj/ip_helper_generic.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/ip_helper_generic.c	(revision 1583)
+++ pjproject/trunk/pjlib/src/pj/ip_helper_generic.c	(revision 1584)
@@ -22,10 +22,8 @@
 #include <pj/errno.h>
 #include <pj/string.h>
+#include <pj/compat/socket.h>
 
-/*
- * Enumerate the local IP interface currently active in the host.
- */
-PJ_DEF(pj_status_t) pj_enum_ip_interface(unsigned *p_cnt,
-					 pj_in_addr ifs[])
+static pj_status_t dummy_enum_ip_interface(unsigned *p_cnt,
+					  pj_in_addr ifs[])
 {
     pj_status_t status;
@@ -42,4 +40,61 @@
     *p_cnt = 1;
     return PJ_SUCCESS;
+}
+
+#ifdef SIOCGIFCONF
+static pj_status_t sock_enum_ip_interface(unsigned *p_cnt,
+					  pj_in_addr ifs[])
+{
+    pj_sock_t sock;
+    char buf[512];
+    struct ifconf ifc;
+    struct ifreq *ifr;
+    int i, count;
+    pj_status_t status;
+
+    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock);
+    if (status != PJ_SUCCESS)
+	return status;
+
+    /* Query available interfaces */
+    ifc.ifc_len = sizeof(buf);
+    ifc.ifc_buf = buf;
+
+    if (ioctl(sock, SIOCGIFCONF, &ifc) < 0) {
+	int oserr = pj_get_netos_error();
+	pj_sock_close(sock);
+	return PJ_RETURN_OS_ERROR(oserr);
+    }
+
+    /* Done with socket */
+    pj_sock_close(sock);
+
+    /* Interface interfaces */
+    ifr = (struct ifreq*) ifc.ifc_req;
+    count = ifc.ifc_len / sizeof(struct ifreq);
+    if (count > *p_cnt)
+	count = *p_cnt;
+    else
+	*p_cnt = count;
+    for (i=0; i<count; ++i) {
+	struct ifreq *itf = &ifr[i];
+	ifs[i].s_addr = ((struct sockaddr_in *)&itf->ifr_addr)->sin_addr.s_addr;
+    }
+
+    return PJ_SUCCESS;
+}
+#endif /* SIOCGIFCONF */
+
+/*
+ * Enumerate the local IP interface currently active in the host.
+ */
+PJ_DEF(pj_status_t) pj_enum_ip_interface(unsigned *p_cnt,
+					 pj_in_addr ifs[])
+{
+#ifdef SIOCGIFCONF
+    if (sock_enum_ip_interface(p_cnt, ifs) == PJ_SUCCESS)
+	return PJ_SUCCESS;
+#endif
+    return dummy_enum_ip_interface(p_cnt, ifs);
 }
 