Index: pjproject/trunk/build.symbian/pjlibU.def
===================================================================
--- pjproject/trunk/build.symbian/pjlibU.def	(revision 1525)
+++ pjproject/trunk/build.symbian/pjlibU.def	(revision 1585)
@@ -13,285 +13,286 @@
 	pj_AF_PACKET                             @ 12 NONAME
 	pj_AF_UNIX                               @ 13 NONAME
-	pj_GUID_STRING_LENGTH                    @ 14 NONAME
-	pj_IPTOS_LOWDELAY                        @ 15 NONAME
-	pj_IPTOS_MINCOST                         @ 16 NONAME
-	pj_IPTOS_RELIABILITY                     @ 17 NONAME
-	pj_IPTOS_THROUGHPUT                      @ 18 NONAME
-	pj_IP_TOS                                @ 19 NONAME
-	pj_MSG_DONTROUTE                         @ 20 NONAME
-	pj_MSG_OOB                               @ 21 NONAME
-	pj_MSG_PEEK                              @ 22 NONAME
-	pj_NO_MEMORY_EXCEPTION                   @ 23 NONAME
-	pj_SOCK_DGRAM                            @ 24 NONAME
-	pj_SOCK_RAW                              @ 25 NONAME
-	pj_SOCK_RDM                              @ 26 NONAME
-	pj_SOCK_STREAM                           @ 27 NONAME
-	pj_SOL_IP                                @ 28 NONAME
-	pj_SOL_IPV6                              @ 29 NONAME
-	pj_SOL_SOCKET                            @ 30 NONAME
-	pj_SOL_TCP                               @ 31 NONAME
-	pj_SOL_UDP                               @ 32 NONAME
-	pj_SO_RCVBUF                             @ 33 NONAME
-	pj_SO_SNDBUF                             @ 34 NONAME
-	pj_SO_TYPE                               @ 35 NONAME
-	pj_ansi_to_unicode                       @ 36 NONAME
-	pj_array_erase                           @ 37 NONAME
-	pj_array_find                            @ 38 NONAME
-	pj_array_insert                          @ 39 NONAME
-	pj_atexit                                @ 40 NONAME
-	pj_atomic_add                            @ 41 NONAME
-	pj_atomic_add_and_get                    @ 42 NONAME
-	pj_atomic_create                         @ 43 NONAME
-	pj_atomic_dec                            @ 44 NONAME
-	pj_atomic_dec_and_get                    @ 45 NONAME
-	pj_atomic_destroy                        @ 46 NONAME
-	pj_atomic_get                            @ 47 NONAME
-	pj_atomic_inc                            @ 48 NONAME
-	pj_atomic_inc_and_get                    @ 49 NONAME
-	pj_atomic_set                            @ 50 NONAME
-	pj_caching_pool_destroy                  @ 51 NONAME
-	pj_caching_pool_init                     @ 52 NONAME
-	pj_create_random_string                  @ 53 NONAME
-	pj_create_unique_string                  @ 54 NONAME
-	pj_dump_config                           @ 55 NONAME
-	pj_elapsed_cycle                         @ 56 NONAME
-	pj_elapsed_msec                          @ 57 NONAME
-	pj_elapsed_nanosec                       @ 58 NONAME
-	pj_elapsed_time                          @ 59 NONAME
-	pj_elapsed_usec                          @ 60 NONAME
-	pj_enter_critical_section                @ 61 NONAME
-	pj_enum_ip_interface                     @ 62 NONAME
-	pj_enum_ip_route                         @ 63 NONAME
-	pj_exception_id_alloc                    @ 64 NONAME
-	pj_exception_id_free                     @ 65 NONAME
-	pj_exception_id_name                     @ 66 NONAME
-	pj_fifobuf_alloc                         @ 67 NONAME
-	pj_fifobuf_free                          @ 68 NONAME
-	pj_fifobuf_init                          @ 69 NONAME
-	pj_fifobuf_max_size                      @ 70 NONAME
-	pj_fifobuf_unalloc                       @ 71 NONAME
-	pj_file_close                            @ 72 NONAME
-	pj_file_delete                           @ 73 NONAME
-	pj_file_exists                           @ 74 NONAME
-	pj_file_flush                            @ 75 NONAME
-	pj_file_getpos                           @ 76 NONAME
-	pj_file_getstat                          @ 77 NONAME
-	pj_file_move                             @ 78 NONAME
-	pj_file_open                             @ 79 NONAME
-	pj_file_read                             @ 80 NONAME
-	pj_file_setpos                           @ 81 NONAME
-	pj_file_size                             @ 82 NONAME
-	pj_file_write                            @ 83 NONAME
-	pj_generate_unique_string                @ 84 NONAME
-	pj_get_netos_error                       @ 85 NONAME
-	pj_get_os_error                          @ 86 NONAME
-	pj_get_timestamp                         @ 87 NONAME
-	pj_get_timestamp_freq                    @ 88 NONAME
-	pj_get_version                           @ 89 NONAME
-	pj_gethostaddr                           @ 90 NONAME
-	pj_gethostbyname                         @ 91 NONAME
-	pj_gethostip                             @ 92 NONAME
-	pj_gethostname                           @ 93 NONAME
-	pj_getpid                                @ 94 NONAME
-	pj_gettimeofday                          @ 95 NONAME
-	pj_hash_calc                             @ 96 NONAME
-	pj_hash_calc_tolower                     @ 97 NONAME
-	pj_hash_count                            @ 98 NONAME
-	pj_hash_create                           @ 99 NONAME
-	pj_hash_first                            @ 100 NONAME
-	pj_hash_get                              @ 101 NONAME
-	pj_hash_next                             @ 102 NONAME
-	pj_hash_set                              @ 103 NONAME
-	pj_hash_set_np                           @ 104 NONAME
-	pj_hash_this                             @ 105 NONAME
-	pj_htonl                                 @ 106 NONAME
-	pj_htons                                 @ 107 NONAME
-	pj_inet_addr                             @ 108 NONAME
-	pj_inet_addr2                            @ 109 NONAME
-	pj_inet_aton                             @ 110 NONAME
-	pj_inet_ntoa                             @ 111 NONAME
-	pj_init                                  @ 112 NONAME
-	pj_ioqueue_accept                        @ 113 NONAME
-	pj_ioqueue_connect                       @ 114 NONAME
-	pj_ioqueue_create                        @ 115 NONAME
-	pj_ioqueue_destroy                       @ 116 NONAME
-	pj_ioqueue_get_user_data                 @ 117 NONAME
-	pj_ioqueue_is_pending                    @ 118 NONAME
-	pj_ioqueue_name                          @ 119 NONAME
-	pj_ioqueue_op_key_init                   @ 120 NONAME
-	pj_ioqueue_poll                          @ 121 NONAME
-	pj_ioqueue_post_completion               @ 122 NONAME
-	pj_ioqueue_recv                          @ 123 NONAME
-	pj_ioqueue_recvfrom                      @ 124 NONAME
-	pj_ioqueue_register_sock                 @ 125 NONAME
-	pj_ioqueue_send                          @ 126 NONAME
-	pj_ioqueue_sendto                        @ 127 NONAME
-	pj_ioqueue_set_lock                      @ 128 NONAME
-	pj_ioqueue_set_user_data                 @ 129 NONAME
-	pj_ioqueue_unregister                    @ 130 NONAME
-	pj_leave_critical_section                @ 131 NONAME
-	pj_list_erase                            @ 132 NONAME
-	pj_list_find_node                        @ 133 NONAME
-	pj_list_insert_after                     @ 134 NONAME
-	pj_list_insert_before                    @ 135 NONAME
-	pj_list_insert_nodes_after               @ 136 NONAME
-	pj_list_insert_nodes_before              @ 137 NONAME
-	pj_list_merge_first                      @ 138 NONAME
-	pj_list_merge_last                       @ 139 NONAME
-	pj_list_search                           @ 140 NONAME
-	pj_list_size                             @ 141 NONAME
-	pj_lock_acquire                          @ 142 NONAME
-	pj_lock_create_null_mutex                @ 143 NONAME
-	pj_lock_create_recursive_mutex           @ 144 NONAME
-	pj_lock_create_semaphore                 @ 145 NONAME
-	pj_lock_create_simple_mutex              @ 146 NONAME
-	pj_lock_destroy                          @ 147 NONAME
-	pj_lock_release                          @ 148 NONAME
-	pj_lock_tryacquire                       @ 149 NONAME
-	pj_log                                   @ 150 NONAME
-	pj_log_1                                 @ 151 NONAME
-	pj_log_2                                 @ 152 NONAME
-	pj_log_3                                 @ 153 NONAME
-	pj_log_4                                 @ 154 NONAME
-	pj_log_5                                 @ 155 NONAME
-	pj_log_get_decor                         @ 156 NONAME
-	pj_log_get_level                         @ 157 NONAME
-	pj_log_get_log_func                      @ 158 NONAME
-	pj_log_set_decor                         @ 159 NONAME
-	pj_log_set_level                         @ 160 NONAME
-	pj_log_set_log_func                      @ 161 NONAME
-	pj_log_write                             @ 162 NONAME
-	pj_mutex_create                          @ 163 NONAME
-	pj_mutex_create_recursive                @ 164 NONAME
-	pj_mutex_create_simple                   @ 165 NONAME
-	pj_mutex_destroy                         @ 166 NONAME
-	pj_mutex_lock                            @ 167 NONAME
-	pj_mutex_trylock                         @ 168 NONAME
-	pj_mutex_unlock                          @ 169 NONAME
-	pj_ntohl                                 @ 170 NONAME
-	pj_ntohs                                 @ 171 NONAME
-	pj_pool_alloc                            @ 172 NONAME
-	pj_pool_alloc_from_block                 @ 173 NONAME
-	pj_pool_allocate_find                    @ 174 NONAME
-	pj_pool_calloc                           @ 175 NONAME
-	pj_pool_create                           @ 176 NONAME
-	pj_pool_create_int                       @ 177 NONAME
-	pj_pool_create_on_buf                    @ 178 NONAME
-	pj_pool_destroy_int                      @ 179 NONAME
-	pj_pool_factory_default_policy           @ 180 NONAME
-	pj_pool_factory_get_default_policy       @ 181 NONAME
-	pj_pool_get_capacity                     @ 182 NONAME
-	pj_pool_get_used_size                    @ 183 NONAME
-	pj_pool_getobjname                       @ 184 NONAME
-	pj_pool_init_int                         @ 185 NONAME
-	pj_pool_release                          @ 186 NONAME
-	pj_pool_reset                            @ 187 NONAME
-	pj_rand                                  @ 188 NONAME
-	pj_rbtree_erase                          @ 189 NONAME
-	pj_rbtree_find                           @ 190 NONAME
-	pj_rbtree_first                          @ 191 NONAME
-	pj_rbtree_init                           @ 192 NONAME
-	pj_rbtree_insert                         @ 193 NONAME
-	pj_rbtree_last                           @ 194 NONAME
-	pj_rbtree_max_height                     @ 195 NONAME
-	pj_rbtree_min_height                     @ 196 NONAME
-	pj_rbtree_next                           @ 197 NONAME
-	pj_rbtree_prev                           @ 198 NONAME
-	pj_register_strerror                     @ 199 NONAME
-	pj_rwmutex_create                        @ 200 NONAME
-	pj_rwmutex_destroy                       @ 201 NONAME
-	pj_rwmutex_lock_read                     @ 202 NONAME
-	pj_rwmutex_lock_write                    @ 203 NONAME
-	pj_rwmutex_unlock_read                   @ 204 NONAME
-	pj_rwmutex_unlock_write                  @ 205 NONAME
-	pj_sem_create                            @ 206 NONAME
-	pj_sem_destroy                           @ 207 NONAME
-	pj_sem_post                              @ 208 NONAME
-	pj_sem_trywait                           @ 209 NONAME
-	pj_sem_wait                              @ 210 NONAME
-	pj_set_netos_error                       @ 211 NONAME
-	pj_set_os_error                          @ 212 NONAME
-	pj_shutdown                              @ 213 NONAME
-	pj_sock_accept                           @ 214 NONAME
-	pj_sock_bind                             @ 215 NONAME
-	pj_sock_bind_in                          @ 216 NONAME
-	pj_sock_close                            @ 217 NONAME
-	pj_sock_connect                          @ 218 NONAME
-	pj_sock_getpeername                      @ 219 NONAME
-	pj_sock_getsockname                      @ 220 NONAME
-	pj_sock_getsockopt                       @ 221 NONAME
-	pj_sock_listen                           @ 222 NONAME
-	pj_sock_recv                             @ 223 NONAME
-	pj_sock_recvfrom                         @ 224 NONAME
-	pj_sock_select                           @ 225 NONAME
-	pj_sock_send                             @ 226 NONAME
-	pj_sock_sendto                           @ 227 NONAME
-	pj_sock_setsockopt                       @ 228 NONAME
-	pj_sock_shutdown                         @ 229 NONAME
-	pj_sock_socket                           @ 230 NONAME
-	pj_sockaddr_in_init                      @ 231 NONAME
-	pj_sockaddr_in_set_str_addr              @ 232 NONAME
-	pj_srand                                 @ 233 NONAME
-	pj_str                                   @ 234 NONAME
-	pj_strassign                             @ 235 NONAME
-	pj_strcat                                @ 236 NONAME
-	pj_strcat2                               @ 237 NONAME
-	pj_strcmp                                @ 238 NONAME
-	pj_strcmp2                               @ 239 NONAME
-	pj_strcpy                                @ 240 NONAME
-	pj_strcpy2                               @ 241 NONAME
-	pj_strdup                                @ 242 NONAME
-	pj_strdup2                               @ 243 NONAME
-	pj_strdup2_with_null                     @ 244 NONAME
-	pj_strdup3                               @ 245 NONAME
-	pj_strdup_with_null                      @ 246 NONAME
-	pj_strerror                              @ 247 NONAME
-	pj_stricmp                               @ 248 NONAME
-	pj_stricmp2                              @ 249 NONAME
-	pj_strltrim                              @ 250 NONAME
-	pj_strncmp                               @ 251 NONAME
-	pj_strncmp2                              @ 252 NONAME
-	pj_strncpy                               @ 253 NONAME
-	pj_strncpy_with_null                     @ 254 NONAME
-	pj_strnicmp                              @ 255 NONAME
-	pj_strnicmp2                             @ 256 NONAME
-	pj_strrtrim                              @ 257 NONAME
-	pj_strtoul                               @ 258 NONAME
-	pj_strtoul2                              @ 259 NONAME
-	pj_strtrim                               @ 260 NONAME
-	pj_symbianos_poll                        @ 261 NONAME
-	pj_symbianos_set_params                  @ 262 NONAME
-	pj_thread_create                         @ 263 NONAME
-	pj_thread_destroy                        @ 264 NONAME
-	pj_thread_get_name                       @ 265 NONAME
-	pj_thread_join                           @ 266 NONAME
-	pj_thread_local_alloc                    @ 267 NONAME
-	pj_thread_local_free                     @ 268 NONAME
-	pj_thread_local_get                      @ 269 NONAME
-	pj_thread_local_set                      @ 270 NONAME
-	pj_thread_register                       @ 271 NONAME
-	pj_thread_resume                         @ 272 NONAME
-	pj_thread_sleep                          @ 273 NONAME
-	pj_thread_this                           @ 274 NONAME
-	pj_time_decode                           @ 275 NONAME
-	pj_time_encode                           @ 276 NONAME
-	pj_time_gmt_to_local                     @ 277 NONAME
-	pj_time_local_to_gmt                     @ 278 NONAME
-	pj_time_val_normalize                    @ 279 NONAME
-	pj_timer_entry_init                      @ 280 NONAME
-	pj_timer_heap_cancel                     @ 281 NONAME
-	pj_timer_heap_count                      @ 282 NONAME
-	pj_timer_heap_create                     @ 283 NONAME
-	pj_timer_heap_destroy                    @ 284 NONAME
-	pj_timer_heap_earliest_time              @ 285 NONAME
-	pj_timer_heap_mem_size                   @ 286 NONAME
-	pj_timer_heap_poll                       @ 287 NONAME
-	pj_timer_heap_schedule                   @ 288 NONAME
-	pj_timer_heap_set_lock                   @ 289 NONAME
-	pj_timer_heap_set_max_timed_out_per_poll @ 290 NONAME
-	pj_unicode_to_ansi                       @ 291 NONAME
-	pj_utoa                                  @ 292 NONAME
-	pj_utoa_pad                              @ 293 NONAME
-	platform_strerror                        @ 294 NONAME
-	snprintf                                 @ 295 NONAME
-	vsnprintf                                @ 296 NONAME
+	pj_AF_UNSPEC                             @ 14 NONAME
+	pj_GUID_STRING_LENGTH                    @ 15 NONAME
+	pj_IPTOS_LOWDELAY                        @ 16 NONAME
+	pj_IPTOS_MINCOST                         @ 17 NONAME
+	pj_IPTOS_RELIABILITY                     @ 18 NONAME
+	pj_IPTOS_THROUGHPUT                      @ 19 NONAME
+	pj_IP_TOS                                @ 20 NONAME
+	pj_MSG_DONTROUTE                         @ 21 NONAME
+	pj_MSG_OOB                               @ 22 NONAME
+	pj_MSG_PEEK                              @ 23 NONAME
+	pj_NO_MEMORY_EXCEPTION                   @ 24 NONAME
+	pj_SOCK_DGRAM                            @ 25 NONAME
+	pj_SOCK_RAW                              @ 26 NONAME
+	pj_SOCK_RDM                              @ 27 NONAME
+	pj_SOCK_STREAM                           @ 28 NONAME
+	pj_SOL_IP                                @ 29 NONAME
+	pj_SOL_IPV6                              @ 30 NONAME
+	pj_SOL_SOCKET                            @ 31 NONAME
+	pj_SOL_TCP                               @ 32 NONAME
+	pj_SOL_UDP                               @ 33 NONAME
+	pj_SO_RCVBUF                             @ 34 NONAME
+	pj_SO_SNDBUF                             @ 35 NONAME
+	pj_SO_TYPE                               @ 36 NONAME
+	pj_ansi_to_unicode                       @ 37 NONAME
+	pj_array_erase                           @ 38 NONAME
+	pj_array_find                            @ 39 NONAME
+	pj_array_insert                          @ 40 NONAME
+	pj_atexit                                @ 41 NONAME
+	pj_atomic_add                            @ 42 NONAME
+	pj_atomic_add_and_get                    @ 43 NONAME
+	pj_atomic_create                         @ 44 NONAME
+	pj_atomic_dec                            @ 45 NONAME
+	pj_atomic_dec_and_get                    @ 46 NONAME
+	pj_atomic_destroy                        @ 47 NONAME
+	pj_atomic_get                            @ 48 NONAME
+	pj_atomic_inc                            @ 49 NONAME
+	pj_atomic_inc_and_get                    @ 50 NONAME
+	pj_atomic_set                            @ 51 NONAME
+	pj_caching_pool_destroy                  @ 52 NONAME
+	pj_caching_pool_init                     @ 53 NONAME
+	pj_create_random_string                  @ 54 NONAME
+	pj_create_unique_string                  @ 55 NONAME
+	pj_dump_config                           @ 56 NONAME
+	pj_elapsed_cycle                         @ 57 NONAME
+	pj_elapsed_msec                          @ 58 NONAME
+	pj_elapsed_nanosec                       @ 59 NONAME
+	pj_elapsed_time                          @ 60 NONAME
+	pj_elapsed_usec                          @ 61 NONAME
+	pj_enter_critical_section                @ 62 NONAME
+	pj_enum_ip_interface                     @ 63 NONAME
+	pj_enum_ip_route                         @ 64 NONAME
+	pj_exception_id_alloc                    @ 65 NONAME
+	pj_exception_id_free                     @ 66 NONAME
+	pj_exception_id_name                     @ 67 NONAME
+	pj_fifobuf_alloc                         @ 68 NONAME
+	pj_fifobuf_free                          @ 69 NONAME
+	pj_fifobuf_init                          @ 70 NONAME
+	pj_fifobuf_max_size                      @ 71 NONAME
+	pj_fifobuf_unalloc                       @ 72 NONAME
+	pj_file_close                            @ 73 NONAME
+	pj_file_delete                           @ 74 NONAME
+	pj_file_exists                           @ 75 NONAME
+	pj_file_flush                            @ 76 NONAME
+	pj_file_getpos                           @ 77 NONAME
+	pj_file_getstat                          @ 78 NONAME
+	pj_file_move                             @ 79 NONAME
+	pj_file_open                             @ 80 NONAME
+	pj_file_read                             @ 81 NONAME
+	pj_file_setpos                           @ 82 NONAME
+	pj_file_size                             @ 83 NONAME
+	pj_file_write                            @ 84 NONAME
+	pj_generate_unique_string                @ 85 NONAME
+	pj_get_netos_error                       @ 86 NONAME
+	pj_get_os_error                          @ 87 NONAME
+	pj_get_timestamp                         @ 88 NONAME
+	pj_get_timestamp_freq                    @ 89 NONAME
+	pj_get_version                           @ 90 NONAME
+	pj_gethostaddr                           @ 91 NONAME
+	pj_gethostbyname                         @ 92 NONAME
+	pj_gethostip                             @ 93 NONAME
+	pj_gethostname                           @ 94 NONAME
+	pj_getpid                                @ 95 NONAME
+	pj_gettimeofday                          @ 96 NONAME
+	pj_hash_calc                             @ 97 NONAME
+	pj_hash_calc_tolower                     @ 98 NONAME
+	pj_hash_count                            @ 99 NONAME
+	pj_hash_create                           @ 100 NONAME
+	pj_hash_first                            @ 101 NONAME
+	pj_hash_get                              @ 102 NONAME
+	pj_hash_next                             @ 103 NONAME
+	pj_hash_set                              @ 104 NONAME
+	pj_hash_set_np                           @ 105 NONAME
+	pj_hash_this                             @ 106 NONAME
+	pj_htonl                                 @ 107 NONAME
+	pj_htons                                 @ 108 NONAME
+	pj_inet_addr                             @ 109 NONAME
+	pj_inet_addr2                            @ 110 NONAME
+	pj_inet_aton                             @ 111 NONAME
+	pj_inet_ntoa                             @ 112 NONAME
+	pj_init                                  @ 113 NONAME
+	pj_ioqueue_accept                        @ 114 NONAME
+	pj_ioqueue_connect                       @ 115 NONAME
+	pj_ioqueue_create                        @ 116 NONAME
+	pj_ioqueue_destroy                       @ 117 NONAME
+	pj_ioqueue_get_user_data                 @ 118 NONAME
+	pj_ioqueue_is_pending                    @ 119 NONAME
+	pj_ioqueue_name                          @ 120 NONAME
+	pj_ioqueue_op_key_init                   @ 121 NONAME
+	pj_ioqueue_poll                          @ 122 NONAME
+	pj_ioqueue_post_completion               @ 123 NONAME
+	pj_ioqueue_recv                          @ 124 NONAME
+	pj_ioqueue_recvfrom                      @ 125 NONAME
+	pj_ioqueue_register_sock                 @ 126 NONAME
+	pj_ioqueue_send                          @ 127 NONAME
+	pj_ioqueue_sendto                        @ 128 NONAME
+	pj_ioqueue_set_lock                      @ 129 NONAME
+	pj_ioqueue_set_user_data                 @ 130 NONAME
+	pj_ioqueue_unregister                    @ 131 NONAME
+	pj_leave_critical_section                @ 132 NONAME
+	pj_list_erase                            @ 133 NONAME
+	pj_list_find_node                        @ 134 NONAME
+	pj_list_insert_after                     @ 135 NONAME
+	pj_list_insert_before                    @ 136 NONAME
+	pj_list_insert_nodes_after               @ 137 NONAME
+	pj_list_insert_nodes_before              @ 138 NONAME
+	pj_list_merge_first                      @ 139 NONAME
+	pj_list_merge_last                       @ 140 NONAME
+	pj_list_search                           @ 141 NONAME
+	pj_list_size                             @ 142 NONAME
+	pj_lock_acquire                          @ 143 NONAME
+	pj_lock_create_null_mutex                @ 144 NONAME
+	pj_lock_create_recursive_mutex           @ 145 NONAME
+	pj_lock_create_semaphore                 @ 146 NONAME
+	pj_lock_create_simple_mutex              @ 147 NONAME
+	pj_lock_destroy                          @ 148 NONAME
+	pj_lock_release                          @ 149 NONAME
+	pj_lock_tryacquire                       @ 150 NONAME
+	pj_log                                   @ 151 NONAME
+	pj_log_1                                 @ 152 NONAME
+	pj_log_2                                 @ 153 NONAME
+	pj_log_3                                 @ 154 NONAME
+	pj_log_4                                 @ 155 NONAME
+	pj_log_5                                 @ 156 NONAME
+	pj_log_get_decor                         @ 157 NONAME
+	pj_log_get_level                         @ 158 NONAME
+	pj_log_get_log_func                      @ 159 NONAME
+	pj_log_set_decor                         @ 160 NONAME
+	pj_log_set_level                         @ 161 NONAME
+	pj_log_set_log_func                      @ 162 NONAME
+	pj_log_write                             @ 163 NONAME
+	pj_mutex_create                          @ 164 NONAME
+	pj_mutex_create_recursive                @ 165 NONAME
+	pj_mutex_create_simple                   @ 166 NONAME
+	pj_mutex_destroy                         @ 167 NONAME
+	pj_mutex_lock                            @ 168 NONAME
+	pj_mutex_trylock                         @ 169 NONAME
+	pj_mutex_unlock                          @ 170 NONAME
+	pj_ntohl                                 @ 171 NONAME
+	pj_ntohs                                 @ 172 NONAME
+	pj_pool_alloc                            @ 173 NONAME
+	pj_pool_alloc_from_block                 @ 174 NONAME
+	pj_pool_allocate_find                    @ 175 NONAME
+	pj_pool_calloc                           @ 176 NONAME
+	pj_pool_create                           @ 177 NONAME
+	pj_pool_create_int                       @ 178 NONAME
+	pj_pool_create_on_buf                    @ 179 NONAME
+	pj_pool_destroy_int                      @ 180 NONAME
+	pj_pool_factory_default_policy           @ 181 NONAME
+	pj_pool_factory_get_default_policy       @ 182 NONAME
+	pj_pool_get_capacity                     @ 183 NONAME
+	pj_pool_get_used_size                    @ 184 NONAME
+	pj_pool_getobjname                       @ 185 NONAME
+	pj_pool_init_int                         @ 186 NONAME
+	pj_pool_release                          @ 187 NONAME
+	pj_pool_reset                            @ 188 NONAME
+	pj_rand                                  @ 189 NONAME
+	pj_rbtree_erase                          @ 190 NONAME
+	pj_rbtree_find                           @ 191 NONAME
+	pj_rbtree_first                          @ 192 NONAME
+	pj_rbtree_init                           @ 193 NONAME
+	pj_rbtree_insert                         @ 194 NONAME
+	pj_rbtree_last                           @ 195 NONAME
+	pj_rbtree_max_height                     @ 196 NONAME
+	pj_rbtree_min_height                     @ 197 NONAME
+	pj_rbtree_next                           @ 198 NONAME
+	pj_rbtree_prev                           @ 199 NONAME
+	pj_register_strerror                     @ 200 NONAME
+	pj_rwmutex_create                        @ 201 NONAME
+	pj_rwmutex_destroy                       @ 202 NONAME
+	pj_rwmutex_lock_read                     @ 203 NONAME
+	pj_rwmutex_lock_write                    @ 204 NONAME
+	pj_rwmutex_unlock_read                   @ 205 NONAME
+	pj_rwmutex_unlock_write                  @ 206 NONAME
+	pj_sem_create                            @ 207 NONAME
+	pj_sem_destroy                           @ 208 NONAME
+	pj_sem_post                              @ 209 NONAME
+	pj_sem_trywait                           @ 210 NONAME
+	pj_sem_wait                              @ 211 NONAME
+	pj_set_netos_error                       @ 212 NONAME
+	pj_set_os_error                          @ 213 NONAME
+	pj_shutdown                              @ 214 NONAME
+	pj_sock_accept                           @ 215 NONAME
+	pj_sock_bind                             @ 216 NONAME
+	pj_sock_bind_in                          @ 217 NONAME
+	pj_sock_close                            @ 218 NONAME
+	pj_sock_connect                          @ 219 NONAME
+	pj_sock_getpeername                      @ 220 NONAME
+	pj_sock_getsockname                      @ 221 NONAME
+	pj_sock_getsockopt                       @ 222 NONAME
+	pj_sock_listen                           @ 223 NONAME
+	pj_sock_recv                             @ 224 NONAME
+	pj_sock_recvfrom                         @ 225 NONAME
+	pj_sock_select                           @ 226 NONAME
+	pj_sock_send                             @ 227 NONAME
+	pj_sock_sendto                           @ 228 NONAME
+	pj_sock_setsockopt                       @ 229 NONAME
+	pj_sock_shutdown                         @ 230 NONAME
+	pj_sock_socket                           @ 231 NONAME
+	pj_sockaddr_in_init                      @ 232 NONAME
+	pj_sockaddr_in_set_str_addr              @ 233 NONAME
+	pj_srand                                 @ 234 NONAME
+	pj_str                                   @ 235 NONAME
+	pj_strassign                             @ 236 NONAME
+	pj_strcat                                @ 237 NONAME
+	pj_strcat2                               @ 238 NONAME
+	pj_strcmp                                @ 239 NONAME
+	pj_strcmp2                               @ 240 NONAME
+	pj_strcpy                                @ 241 NONAME
+	pj_strcpy2                               @ 242 NONAME
+	pj_strdup                                @ 243 NONAME
+	pj_strdup2                               @ 244 NONAME
+	pj_strdup2_with_null                     @ 245 NONAME
+	pj_strdup3                               @ 246 NONAME
+	pj_strdup_with_null                      @ 247 NONAME
+	pj_strerror                              @ 248 NONAME
+	pj_stricmp                               @ 249 NONAME
+	pj_stricmp2                              @ 250 NONAME
+	pj_strltrim                              @ 251 NONAME
+	pj_strncmp                               @ 252 NONAME
+	pj_strncmp2                              @ 253 NONAME
+	pj_strncpy                               @ 254 NONAME
+	pj_strncpy_with_null                     @ 255 NONAME
+	pj_strnicmp                              @ 256 NONAME
+	pj_strnicmp2                             @ 257 NONAME
+	pj_strrtrim                              @ 258 NONAME
+	pj_strtoul                               @ 259 NONAME
+	pj_strtoul2                              @ 260 NONAME
+	pj_strtrim                               @ 261 NONAME
+	pj_symbianos_poll                        @ 262 NONAME
+	pj_symbianos_set_params                  @ 263 NONAME
+	pj_thread_create                         @ 264 NONAME
+	pj_thread_destroy                        @ 265 NONAME
+	pj_thread_get_name                       @ 266 NONAME
+	pj_thread_join                           @ 267 NONAME
+	pj_thread_local_alloc                    @ 268 NONAME
+	pj_thread_local_free                     @ 269 NONAME
+	pj_thread_local_get                      @ 270 NONAME
+	pj_thread_local_set                      @ 271 NONAME
+	pj_thread_register                       @ 272 NONAME
+	pj_thread_resume                         @ 273 NONAME
+	pj_thread_sleep                          @ 274 NONAME
+	pj_thread_this                           @ 275 NONAME
+	pj_time_decode                           @ 276 NONAME
+	pj_time_encode                           @ 277 NONAME
+	pj_time_gmt_to_local                     @ 278 NONAME
+	pj_time_local_to_gmt                     @ 279 NONAME
+	pj_time_val_normalize                    @ 280 NONAME
+	pj_timer_entry_init                      @ 281 NONAME
+	pj_timer_heap_cancel                     @ 282 NONAME
+	pj_timer_heap_count                      @ 283 NONAME
+	pj_timer_heap_create                     @ 284 NONAME
+	pj_timer_heap_destroy                    @ 285 NONAME
+	pj_timer_heap_earliest_time              @ 286 NONAME
+	pj_timer_heap_mem_size                   @ 287 NONAME
+	pj_timer_heap_poll                       @ 288 NONAME
+	pj_timer_heap_schedule                   @ 289 NONAME
+	pj_timer_heap_set_lock                   @ 290 NONAME
+	pj_timer_heap_set_max_timed_out_per_poll @ 291 NONAME
+	pj_unicode_to_ansi                       @ 292 NONAME
+	pj_utoa                                  @ 293 NONAME
+	pj_utoa_pad                              @ 294 NONAME
+	platform_strerror                        @ 295 NONAME
+	snprintf                                 @ 296 NONAME
+	vsnprintf                                @ 297 NONAME